import { RedisClientType } from "@redis/client";
import { IncomingMessage, ServerResponse } from "http";

/**
 * Global variable
**/
declare global{
    //系统对象
    let SYSTEM:any;
    //全局FS对象
    let FILE:any;
    //全局Moment
    let Moment:Moment;
    //Logger
    declare namespace LOGGER {
        function log(msg:string):void;
        function info(msg:string):void;
        function debug(msg:string):void;
        function warn(msg:string):void;
        function error(msg:string):void;
    }
    //数据库配置项接口
    declare interface DBOption{
        host:string,
        port:number,
        username?:string,
        password?:string,
        database?:string,
        prefix?:string
    }
    declare function DBCallback(err:Error,data:any):void;
    declare function H(helperName:string):any;
    declare function M(moduleName:string):any;
    // declare namespace DBManager {
    //     function create(DatabaseType:string,option:DBOption,GlobalName?:string,callback?:(err:Error|null,conn?:any)=>void);
    //     /**
    //      * @param dbname 数据库名称,目前支持: redis | mysql | mongodb | memcache
    //      */
    //     function getOption(dbname:string):DBOption;
    // }
    // let ROOTPATH:string;
    // let SYSTEM:object;

    declare interface RequestData{
        req:IncomingMessage|undefined,
        res:ServerResponse|undefined,
        path:string|null,
        COOKIE:any,
        GET:any,
        POST:any,
        UPLOAD:any
    }
    declare class CONTROLLER{
        end(data:any,status?:number,mime?:string):void;
        endRedirect(location:string,permanently:boolean);
        endJSON(somthing:any);
        endAPI(errorCode:number,somthing:any);
        endView(viewname:string,data:any,option?:any);
        setCookie(key:string,value:any,expire?:number|'forever',path?:string);
        renewCookie(key:string,expire:number|'forever',path?:string);
    }
}

export = {}